/*
    This program uses a (binary) semaphore to avoid the race condition.
*/
#include <windows.h>   // Win32 Sleep()
#include <unistd.h>    // Linux sleep()
#include <stdio.h>     // printf()
#include "pthread.h"
#include "semaphore.h"

// global variables
int runFlag = 1;
unsigned int count  = 0;  // this variable is shared by thread1 and thread2
unsigned int count1 = 0;  // this variable is used only by thread1
unsigned int count2 = 0;  // this variable is used only by thread2

sem_t semaphore;

int main( int argc, char *argv[])
{
   void *thread1(void *vargp);  //thread function prototypes
   void *thread2(void *vargp);

   int threadParam1 = 0;  // thread function parameters
   int threadParam2 = 0;

   pthread_t tid1;
   pthread_t tid2;

   // initialize the (binary) semaphore (in signaled state)
   sem_init(&semaphore, 0, 1);

   // create two threads
   printf("race2s: Starting threads\n");
   pthread_create(&tid1, NULL, thread1, &threadParam1);
   pthread_create(&tid2, NULL, thread2, &threadParam2);

   Sleep(2000);  //sleep(2);     // let the threads run for a while
   runFlag = 0;                  // signal the threads to stop

   pthread_join(tid1, NULL);     // wait for the threads to stop
   pthread_join(tid2, NULL);

   printf("\nThreads stopped.\n");
   printf("count = %d, count1 = %d, count2 = %d\n", count, count1, count2);

   return 0;
}//main


void *thread1(void *vargp)
{
   unsigned int new_count, old_count;
   while(runFlag)
   {
      sem_wait(&semaphore);
      old_count = count++;
      new_count = count;
      sem_post(&semaphore);

      if (new_count - old_count != 1)
         printf("Bingo1: new_count - old_count = %d\n", new_count-old_count);
      count1++;
   }
   return NULL;
}//thread1


void *thread2(void *vargp)
{
   unsigned int new_count, old_count;
   while(runFlag)
   {
      sem_wait(&semaphore);
      old_count = count++;
      new_count = count;
      sem_post(&semaphore);

      if (new_count - old_count != 1)
         printf("Bingo2: new_count - old_count = %d\n", new_count-old_count);
      count2++;
   }
   return NULL;
}//thread2
